#
# Constraints common to all banks of DDR4 SDRAM
#

# Define system clock for banks 0 and 1 (Clock region X2Y0/IO Column 1))
set_property PACKAGE_PIN AK22 [get_ports {c01_sys_clk_p}] ; # Bank 44
set_property IOSTANDARD LVDS [get_ports {c01_sys_clk_p}]
set_property DIFF_TERM_ADV TERM_100 [get_ports {c01_sys_clk_p}]

set_property PACKAGE_PIN AL22 [get_ports {c01_sys_clk_n}] ; # Bank 44
set_property IOSTANDARD LVDS [get_ports {c01_sys_clk_n}]
set_property DIFF_TERM_ADV TERM_100 [get_ports {c01_sys_clk_n}]

create_clock -period 3.333 -name sysclk01 [get_ports {c01_sys_clk_p}]


# Define system clock for banks 2 and 3 (Clock region X4Y0/IO Column 2))
set_property PACKAGE_PIN AN18 [get_ports {c23_sys_clk_p}] ; # Bank 64
set_property IOSTANDARD LVDS_25 [get_ports {c23_sys_clk_p}]
set_property DIFF_TERM_ADV TERM_100 [get_ports {c23_sys_clk_p}]

set_property PACKAGE_PIN AN17 [ get_ports {c23_sys_clk_n}] ; # Bank 64
set_property IOSTANDARD LVDS_25 [get_ports {c23_sys_clk_n}]
set_property DIFF_TERM_ADV TERM_100 [get_ports {c23_sys_clk_n}]

create_clock -period 3.333 -name sysclk23 [get_ports {c23_sys_clk_p}]


# See PG150: UltraScale Architecture FPGAs Memory Interface Solutions v7.1: Sharing of Input Clock Source (sys_clk_p)
set_property CLOCK_DEDICATED_ROUTE BACKBONE [get_nets -of_objects [get_pins {ddr4_clk01_dif_i/O}]]
set_property CLOCK_DEDICATED_ROUTE BACKBONE [get_nets -of_objects [get_pins {ddr4_clk23_dif_i/O}]]


# Set properties for unused MIG inputs
set_property IOSTANDARD LVCMOS12   [get_ports [list c?_ddr4_alert_n]]

# Set properties for unused MIG outputs
set_property IOSTANDARD SSTL12_DCI [get_ports [list c?_ddr4_par]]
set_property IOSTANDARD LVCMOS12   [get_ports [list c?_ddr4_ten]]

set_property drive 8 [get_ports [list c?_ddr4_ten]]
