set VAR_SIM_AXI     [examine /tb_dma_demo/sim_axi]
set VAR_SER_WIDTH   [examine /tb_dma_demo/MPTL_SER_WIDTH]
set VAR_MODEL       [examine /tb_dma_demo/MODEL_NAME]

if $VAR_SIM_AXI then {
  set VAR_SIM "sim_axi"
} else {
  set VAR_SIM "sim_mptl"
}

set wave_pat {
/tb_dma_demo/*
/tb_dma_demo/uut/*
/tb_dma_demo/uut/mptl_tgt_ku_axi_wrap_i/mptl_tgt_ku_axi_sim_g/mptl_tgt_ku_axi_sim_i/tb_dma_demo_stim_i/*
/tb_dma_demo/uut/dma0_blk_mem_gen_i/*
/tb_dma_demo/uut/dma1_blk_mem_gen_i/*
}

noview *
view signals
view structure
view wave -title "dma_demo (${VAR_MODEL}, MPTLx${VAR_SER_WIDTH}, ${VAR_SIM})"

radix hex

foreach pattern $wave_pat {
  add wave -group $pattern $pattern
}

configure wave -signalnamewidth 1

set NumericStdNoWarnings 1
set StdArithNoWarnings 1
