set VAR_SIM_AXI     [examine /tb_dma_demo_pcie/sim_axi]
set VAR_SER_WIDTH   [examine /tb_dma_demo_pcie/PCIE_SER_WIDTH]
set VAR_MODEL       [examine /tb_dma_demo_pcie/MODEL_NAME]

if $VAR_SIM_AXI then {
  set VAR_SIM "sim_axi"
} else {
  set VAR_SIM "sim_pcie"
}

set wave_pat {
/tb_dma_demo_pcie/*
/tb_dma_demo_pcie/uut/*
/tb_dma_demo_pcie/uut/dma0_blk_mem_gen_i/*
/tb_dma_demo_pcie/uut/dma1_blk_mem_gen_i/*
/tb_dma_demo_pcie/uut/dma2_blk_mem_gen_i/*
/tb_dma_demo_pcie/uut/dma3_blk_mem_gen_i/*
}

noview *
view signals
view structure
view wave -title "dma_demo_pcie (${VAR_MODEL}, MPTLx${VAR_SER_WIDTH}, ${VAR_SIM})"

radix hex

foreach pattern $wave_pat {
  add wave -group $pattern $pattern
}

configure wave -signalnamewidth 1

set NumericStdNoWarnings 1
set StdArithNoWarnings 1
