set VAR_SIM_AXI     [get_value /tb_dma_demo_pcie/sim_axi]
set VAR_SER_WIDTH   [get_value /tb_dma_demo_pcie/PCIE_SER_WIDTH]
set VAR_MODEL       [get_value /tb_dma_demo_pcie/MODEL_NAME]

if $VAR_SIM_AXI then {
  set VAR_SIM "sim_axi"
} else {
  set VAR_SIM "sim_pcie"
}

set wave_pat {
/tb_dma_demo_pcie
/tb_dma_demo_pcie/uut
/tb_dma_demo_pcie/uut/dma0_blk_mem_gen_i
/tb_dma_demo_pcie/uut/dma1_blk_mem_gen_i
/tb_dma_demo_pcie/uut/dma2_blk_mem_gen_i
/tb_dma_demo_pcie/uut/dma3_blk_mem_gen_i
}

close_wave_config -force
create_wave_config -name "dma_demo_pcie (${VAR_MODEL}, PCIEx${VAR_SER_WIDTH}, ${VAR_SIM})"

foreach pattern $wave_pat {
  add_wave_group $pattern
  add_wave -into $pattern -radix hex $pattern
}

set NumericStdNoWarnings 1
set StdArithNoWarnings 1

set run_list [get_property {xsim.simulate.runtime} [current_fileset -simset]]
run [lindex $run_list 0] [lindex $run_list 1]
