library ieee;
use ieee.std_logic_1164.all;

entity adb3_admxrcku1_wrap is
generic(
  sim_axi : boolean := false);
port(
  refclk300_p  : in    std_logic;
  refclk300_n  : in    std_logic;
  refclk       : out   std_logic;
  --
  perst_n   : in    std_logic;
  pcie100_p : in    std_logic;
  pcie100_n : in    std_logic;
  pci_t2h_p : out   std_logic_vector(7 downto 0);
  pci_t2h_n : out   std_logic_vector(7 downto 0);
  pci_h2t_p : in    std_logic_vector(7 downto 0);
  pci_h2t_n : in    std_logic_vector(7 downto 0);
  --
  vpd_out : out   std_logic_vector(47 downto 0);
  --
  avr_clk : in    std_logic;
  avr_b2t : in    std_logic;
  avr_t2b : out   std_logic;
  --
  aclk    : out   std_logic;
  aresetn : out   std_logic;
  --
  ds_axi_awaddr   : out   std_logic_vector(63 downto 0);
  ds_axi_awlen    : out   std_logic_vector(7 downto 0);
  ds_axi_awsize   : out   std_logic_vector(2 downto 0);
  ds_axi_awburst  : out   std_logic_vector(1 downto 0);
  ds_axi_awcache  : out   std_logic_vector(3 downto 0);
  ds_axi_awprot   : out   std_logic_vector(2 downto 0);
  ds_axi_awvalid  : out   std_logic;
  ds_axi_wdata    : out   std_logic_vector(255 downto 0);
  ds_axi_wstrb    : out   std_logic_vector(31 downto 0);
  ds_axi_wlast    : out   std_logic;
  ds_axi_wvalid   : out   std_logic;
  ds_axi_bready   : out   std_logic;
  ds_axi_araddr   : out   std_logic_vector(63 downto 0);
  ds_axi_arlen    : out   std_logic_vector(7 downto 0);
  ds_axi_arsize   : out   std_logic_vector(2 downto 0);
  ds_axi_arburst  : out   std_logic_vector(1 downto 0);
  ds_axi_arcache  : out   std_logic_vector(3 downto 0);
  ds_axi_arprot   : out   std_logic_vector(2 downto 0);
  ds_axi_arvalid  : out   std_logic;
  ds_axi_rready   : out   std_logic;
  ds_axi_awready  : in    std_logic;
  ds_axi_wready   : in    std_logic;
  ds_axi_bresp    : in    std_logic_vector(1 downto 0);
  ds_axi_bvalid   : in    std_logic;
  ds_axi_arready  : in    std_logic;
  ds_axi_rdata    : in    std_logic_vector(255 downto 0);
  ds_axi_rresp    : in    std_logic_vector(1 downto 0);
  ds_axi_rlast    : in    std_logic;
  ds_axi_rvalid   : in    std_logic;
  ds_axi_awlock   : out   std_logic_vector(0 downto 0);
  ds_axi_awqos    : out   std_logic_vector(3 downto 0);
  ds_axi_arlock   : out   std_logic_vector(0 downto 0);
  ds_axi_arqos    : out   std_logic_vector(3 downto 0);
  ds_axi_awregion : out   std_logic_vector(3 downto 0);
  ds_axi_arregion : out   std_logic_vector(3 downto 0);
  --
  dma0_axi_awaddr   : out   std_logic_vector(38 downto 0);
  dma0_axi_awlen    : out   std_logic_vector(7 downto 0);
  dma0_axi_awsize   : out   std_logic_vector(2 downto 0);
  dma0_axi_awburst  : out   std_logic_vector(1 downto 0);
  dma0_axi_awcache  : out   std_logic_vector(3 downto 0);
  dma0_axi_awprot   : out   std_logic_vector(2 downto 0);
  dma0_axi_awvalid  : out   std_logic;
  dma0_axi_wdata    : out   std_logic_vector(255 downto 0);
  dma0_axi_wstrb    : out   std_logic_vector(31 downto 0);
  dma0_axi_wlast    : out   std_logic;
  dma0_axi_wvalid   : out   std_logic;
  dma0_axi_bready   : out   std_logic;
  dma0_axi_araddr   : out   std_logic_vector(38 downto 0);
  dma0_axi_arlen    : out   std_logic_vector(7 downto 0);
  dma0_axi_arsize   : out   std_logic_vector(2 downto 0);
  dma0_axi_arburst  : out   std_logic_vector(1 downto 0);
  dma0_axi_arcache  : out   std_logic_vector(3 downto 0);
  dma0_axi_arprot   : out   std_logic_vector(2 downto 0);
  dma0_axi_arvalid  : out   std_logic;
  dma0_axi_rready   : out   std_logic;
  dma0_axi_awready  : in    std_logic;
  dma0_axi_wready   : in    std_logic;
  dma0_axi_bresp    : in    std_logic_vector(1 downto 0);
  dma0_axi_bvalid   : in    std_logic;
  dma0_axi_arready  : in    std_logic;
  dma0_axi_rdata    : in    std_logic_vector(255 downto 0);
  dma0_axi_rresp    : in    std_logic_vector(1 downto 0);
  dma0_axi_rlast    : in    std_logic;
  dma0_axi_rvalid   : in    std_logic;
  dma0_axi_awlock   : out   std_logic_vector(0 downto 0);
  dma0_axi_awqos    : out   std_logic_vector(3 downto 0);
  dma0_axi_arlock   : out   std_logic_vector(0 downto 0);
  dma0_axi_arqos    : out   std_logic_vector(3 downto 0);
  dma0_axi_awregion : out   std_logic_vector(3 downto 0);
  dma0_axi_arregion : out   std_logic_vector(3 downto 0);
  --
  dma1_axi_awaddr   : out   std_logic_vector(38 downto 0);
  dma1_axi_awlen    : out   std_logic_vector(7 downto 0);
  dma1_axi_awsize   : out   std_logic_vector(2 downto 0);
  dma1_axi_awburst  : out   std_logic_vector(1 downto 0);
  dma1_axi_awcache  : out   std_logic_vector(3 downto 0);
  dma1_axi_awprot   : out   std_logic_vector(2 downto 0);
  dma1_axi_awvalid  : out   std_logic;
  dma1_axi_wdata    : out   std_logic_vector(255 downto 0);
  dma1_axi_wstrb    : out   std_logic_vector(31 downto 0);
  dma1_axi_wlast    : out   std_logic;
  dma1_axi_wvalid   : out   std_logic;
  dma1_axi_bready   : out   std_logic;
  dma1_axi_araddr   : out   std_logic_vector(38 downto 0);
  dma1_axi_arlen    : out   std_logic_vector(7 downto 0);
  dma1_axi_arsize   : out   std_logic_vector(2 downto 0);
  dma1_axi_arburst  : out   std_logic_vector(1 downto 0);
  dma1_axi_arcache  : out   std_logic_vector(3 downto 0);
  dma1_axi_arprot   : out   std_logic_vector(2 downto 0);
  dma1_axi_arvalid  : out   std_logic;
  dma1_axi_rready   : out   std_logic;
  dma1_axi_awready  : in    std_logic;
  dma1_axi_wready   : in    std_logic;
  dma1_axi_bresp    : in    std_logic_vector(1 downto 0);
  dma1_axi_bvalid   : in    std_logic;
  dma1_axi_arready  : in    std_logic;
  dma1_axi_rdata    : in    std_logic_vector(255 downto 0);
  dma1_axi_rresp    : in    std_logic_vector(1 downto 0);
  dma1_axi_rlast    : in    std_logic;
  dma1_axi_rvalid   : in    std_logic;
  dma1_axi_awlock   : out   std_logic_vector(0 downto 0);
  dma1_axi_awqos    : out   std_logic_vector(3 downto 0);
  dma1_axi_arlock   : out   std_logic_vector(0 downto 0);
  dma1_axi_arqos    : out   std_logic_vector(3 downto 0);
  dma1_axi_awregion : out   std_logic_vector(3 downto 0);
  dma1_axi_arregion : out   std_logic_vector(3 downto 0);
  --
  dma2_axi_awaddr   : out   std_logic_vector(38 downto 0);
  dma2_axi_awlen    : out   std_logic_vector(7 downto 0);
  dma2_axi_awsize   : out   std_logic_vector(2 downto 0);
  dma2_axi_awburst  : out   std_logic_vector(1 downto 0);
  dma2_axi_awcache  : out   std_logic_vector(3 downto 0);
  dma2_axi_awprot   : out   std_logic_vector(2 downto 0);
  dma2_axi_awvalid  : out   std_logic;
  dma2_axi_wdata    : out   std_logic_vector(255 downto 0);
  dma2_axi_wstrb    : out   std_logic_vector(31 downto 0);
  dma2_axi_wlast    : out   std_logic;
  dma2_axi_wvalid   : out   std_logic;
  dma2_axi_bready   : out   std_logic;
  dma2_axi_araddr   : out   std_logic_vector(38 downto 0);
  dma2_axi_arlen    : out   std_logic_vector(7 downto 0);
  dma2_axi_arsize   : out   std_logic_vector(2 downto 0);
  dma2_axi_arburst  : out   std_logic_vector(1 downto 0);
  dma2_axi_arcache  : out   std_logic_vector(3 downto 0);
  dma2_axi_arprot   : out   std_logic_vector(2 downto 0);
  dma2_axi_arvalid  : out   std_logic;
  dma2_axi_rready   : out   std_logic;
  dma2_axi_awready  : in    std_logic;
  dma2_axi_wready   : in    std_logic;
  dma2_axi_bresp    : in    std_logic_vector(1 downto 0);
  dma2_axi_bvalid   : in    std_logic;
  dma2_axi_arready  : in    std_logic;
  dma2_axi_rdata    : in    std_logic_vector(255 downto 0);
  dma2_axi_rresp    : in    std_logic_vector(1 downto 0);
  dma2_axi_rlast    : in    std_logic;
  dma2_axi_rvalid   : in    std_logic;
  dma2_axi_awlock   : out   std_logic_vector(0 downto 0);
  dma2_axi_awqos    : out   std_logic_vector(3 downto 0);
  dma2_axi_arlock   : out   std_logic_vector(0 downto 0);
  dma2_axi_arqos    : out   std_logic_vector(3 downto 0);
  dma2_axi_awregion : out   std_logic_vector(3 downto 0);
  dma2_axi_arregion : out   std_logic_vector(3 downto 0);
  --
  dma3_axi_awaddr   : out   std_logic_vector(38 downto 0);
  dma3_axi_awlen    : out   std_logic_vector(7 downto 0);
  dma3_axi_awsize   : out   std_logic_vector(2 downto 0);
  dma3_axi_awburst  : out   std_logic_vector(1 downto 0);
  dma3_axi_awcache  : out   std_logic_vector(3 downto 0);
  dma3_axi_awprot   : out   std_logic_vector(2 downto 0);
  dma3_axi_awvalid  : out   std_logic;
  dma3_axi_wdata    : out   std_logic_vector(255 downto 0);
  dma3_axi_wstrb    : out   std_logic_vector(31 downto 0);
  dma3_axi_wlast    : out   std_logic;
  dma3_axi_wvalid   : out   std_logic;
  dma3_axi_bready   : out   std_logic;
  dma3_axi_araddr   : out   std_logic_vector(38 downto 0);
  dma3_axi_arlen    : out   std_logic_vector(7 downto 0);
  dma3_axi_arsize   : out   std_logic_vector(2 downto 0);
  dma3_axi_arburst  : out   std_logic_vector(1 downto 0);
  dma3_axi_arcache  : out   std_logic_vector(3 downto 0);
  dma3_axi_arprot   : out   std_logic_vector(2 downto 0);
  dma3_axi_arvalid  : out   std_logic;
  dma3_axi_rready   : out   std_logic;
  dma3_axi_awready  : in    std_logic;
  dma3_axi_wready   : in    std_logic;
  dma3_axi_bresp    : in    std_logic_vector(1 downto 0);
  dma3_axi_bvalid   : in    std_logic;
  dma3_axi_arready  : in    std_logic;
  dma3_axi_rdata    : in    std_logic_vector(255 downto 0);
  dma3_axi_rresp    : in    std_logic_vector(1 downto 0);
  dma3_axi_rlast    : in    std_logic;
  dma3_axi_rvalid   : in    std_logic;
  dma3_axi_awlock   : out   std_logic_vector(0 downto 0);
  dma3_axi_awqos    : out   std_logic_vector(3 downto 0);
  dma3_axi_arlock   : out   std_logic_vector(0 downto 0);
  dma3_axi_arqos    : out   std_logic_vector(3 downto 0);
  dma3_axi_awregion : out   std_logic_vector(3 downto 0);
  dma3_axi_arregion : out   std_logic_vector(3 downto 0);
  --
  core_status : out   std_logic_vector(63 downto 0));
end;


architecture synth of adb3_admxrcku1_wrap is

  -- Unused IO

begin

  adb3_admxrcku1_x8_axi4_g : if (sim_axi = false) generate
    component adb3_admxrcku1_x8_axi4_ip
    port(
      refclk300_p  : in    std_logic;
      refclk300_n  : in    std_logic;
      refclk       : out   std_logic;
      --
      perst_n     : in    std_logic;
      pcie100_p   : in    std_logic;
      pcie100_n   : in    std_logic;
      pci_exp_txn : out   std_logic_vector(7 downto 0);
      pci_exp_txp : out   std_logic_vector(7 downto 0);
      pci_exp_rxn : in    std_logic_vector(7 downto 0);
      pci_exp_rxp : in    std_logic_vector(7 downto 0);
      --
      vpd_out : out   std_logic_vector(47 downto 0);
      --
      avr_clk : in    std_logic;
      avr_b2t : in    std_logic;
      avr_t2b : out   std_logic;
      --
      aclk    : out   std_logic;
      aresetn : out   std_logic;
      --
      ds_axi_awaddr   : out   std_logic_vector(63 downto 0);
      ds_axi_awlen    : out   std_logic_vector(7 downto 0);
      ds_axi_awsize   : out   std_logic_vector(2 downto 0);
      ds_axi_awburst  : out   std_logic_vector(1 downto 0);
      ds_axi_awcache  : out   std_logic_vector(3 downto 0);
      ds_axi_awprot   : out   std_logic_vector(2 downto 0);
      ds_axi_awvalid  : out   std_logic;
      ds_axi_wdata    : out   std_logic_vector(255 downto 0);
      ds_axi_wstrb    : out   std_logic_vector(31 downto 0);
      ds_axi_wlast    : out   std_logic;
      ds_axi_wvalid   : out   std_logic;
      ds_axi_bready   : out   std_logic;
      ds_axi_araddr   : out   std_logic_vector(63 downto 0);
      ds_axi_arlen    : out   std_logic_vector(7 downto 0);
      ds_axi_arsize   : out   std_logic_vector(2 downto 0);
      ds_axi_arburst  : out   std_logic_vector(1 downto 0);
      ds_axi_arcache  : out   std_logic_vector(3 downto 0);
      ds_axi_arprot   : out   std_logic_vector(2 downto 0);
      ds_axi_arvalid  : out   std_logic;
      ds_axi_rready   : out   std_logic;
      ds_axi_awready  : in    std_logic;
      ds_axi_wready   : in    std_logic;
      ds_axi_bresp    : in    std_logic_vector(1 downto 0);
      ds_axi_bvalid   : in    std_logic;
      ds_axi_arready  : in    std_logic;
      ds_axi_rdata    : in    std_logic_vector(255 downto 0);
      ds_axi_rresp    : in    std_logic_vector(1 downto 0);
      ds_axi_rlast    : in    std_logic;
      ds_axi_rvalid   : in    std_logic;
      ds_axi_awlock   : out   std_logic_vector(0 downto 0);
      ds_axi_awqos    : out   std_logic_vector(3 downto 0);
      ds_axi_arlock   : out   std_logic_vector(0 downto 0);
      ds_axi_arqos    : out   std_logic_vector(3 downto 0);
      ds_axi_awregion : out   std_logic_vector(3 downto 0);
      ds_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma0_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma0_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma0_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma0_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma0_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma0_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma0_axi_awvalid  : out   std_logic;
      dma0_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma0_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma0_axi_wlast    : out   std_logic;
      dma0_axi_wvalid   : out   std_logic;
      dma0_axi_bready   : out   std_logic;
      dma0_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma0_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma0_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma0_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma0_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma0_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma0_axi_arvalid  : out   std_logic;
      dma0_axi_rready   : out   std_logic;
      dma0_axi_awready  : in    std_logic;
      dma0_axi_wready   : in    std_logic;
      dma0_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma0_axi_bvalid   : in    std_logic;
      dma0_axi_arready  : in    std_logic;
      dma0_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma0_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma0_axi_rlast    : in    std_logic;
      dma0_axi_rvalid   : in    std_logic;
      dma0_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma0_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma0_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma0_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma0_axi_awregion : out   std_logic_vector(3 downto 0);
      dma0_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma1_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma1_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma1_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma1_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma1_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma1_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma1_axi_awvalid  : out   std_logic;
      dma1_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma1_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma1_axi_wlast    : out   std_logic;
      dma1_axi_wvalid   : out   std_logic;
      dma1_axi_bready   : out   std_logic;
      dma1_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma1_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma1_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma1_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma1_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma1_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma1_axi_arvalid  : out   std_logic;
      dma1_axi_rready   : out   std_logic;
      dma1_axi_awready  : in    std_logic;
      dma1_axi_wready   : in    std_logic;
      dma1_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma1_axi_bvalid   : in    std_logic;
      dma1_axi_arready  : in    std_logic;
      dma1_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma1_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma1_axi_rlast    : in    std_logic;
      dma1_axi_rvalid   : in    std_logic;
      dma1_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma1_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma1_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma1_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma1_axi_awregion : out   std_logic_vector(3 downto 0);
      dma1_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma2_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma2_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma2_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma2_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma2_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma2_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma2_axi_awvalid  : out   std_logic;
      dma2_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma2_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma2_axi_wlast    : out   std_logic;
      dma2_axi_wvalid   : out   std_logic;
      dma2_axi_bready   : out   std_logic;
      dma2_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma2_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma2_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma2_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma2_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma2_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma2_axi_arvalid  : out   std_logic;
      dma2_axi_rready   : out   std_logic;
      dma2_axi_awready  : in    std_logic;
      dma2_axi_wready   : in    std_logic;
      dma2_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma2_axi_bvalid   : in    std_logic;
      dma2_axi_arready  : in    std_logic;
      dma2_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma2_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma2_axi_rlast    : in    std_logic;
      dma2_axi_rvalid   : in    std_logic;
      dma2_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma2_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma2_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma2_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma2_axi_awregion : out   std_logic_vector(3 downto 0);
      dma2_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma3_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma3_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma3_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma3_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma3_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma3_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma3_axi_awvalid  : out   std_logic;
      dma3_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma3_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma3_axi_wlast    : out   std_logic;
      dma3_axi_wvalid   : out   std_logic;
      dma3_axi_bready   : out   std_logic;
      dma3_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma3_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma3_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma3_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma3_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma3_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma3_axi_arvalid  : out   std_logic;
      dma3_axi_rready   : out   std_logic;
      dma3_axi_awready  : in    std_logic;
      dma3_axi_wready   : in    std_logic;
      dma3_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma3_axi_bvalid   : in    std_logic;
      dma3_axi_arready  : in    std_logic;
      dma3_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma3_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma3_axi_rlast    : in    std_logic;
      dma3_axi_rvalid   : in    std_logic;
      dma3_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma3_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma3_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma3_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma3_axi_awregion : out   std_logic_vector(3 downto 0);
      dma3_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      core_status : out   std_logic_vector(63 downto 0));
    end component;
  begin
    -- IP synthesis
    adb3_admxrcku1_x8_axi4_i : adb3_admxrcku1_x8_axi4_ip
    port map(
      refclk300_p  => refclk300_p,  -- in    std_logic
      refclk300_n  => refclk300_n,  -- in    std_logic
      refclk       => refclk,       -- out   std_logic
      --
      perst_n     => perst_n,   --  in    std_logic
      pcie100_p   => pcie100_p, --  in    std_logic
      pcie100_n   => pcie100_n, --  in    std_logic
      pci_exp_txn => pci_t2h_n, --  out   std_logic_vector(7 downto 0)
      pci_exp_txp => pci_t2h_p, --  out   std_logic_vector(7 downto 0)
      pci_exp_rxn => pci_h2t_n, --  in    std_logic_vector(7 downto 0)
      pci_exp_rxp => pci_h2t_p, --  in    std_logic_vector(7 downto 0)
      --
      vpd_out => vpd_out, -- out   std_logic_vector(47 downto 0)
      --
      avr_clk => avr_clk, -- in    std_logic;
      avr_b2t => avr_b2t, -- in    std_logic;
      avr_t2b => avr_t2b, -- out   std_logic;
      --
      aclk    => aclk,    -- out   std_logic;
      aresetn => aresetn, -- out   std_logic;
      --
      ds_axi_awaddr   => ds_axi_awaddr,   -- out   std_logic_vector(63 downto 0);
      ds_axi_awlen    => ds_axi_awlen,    -- out   std_logic_vector(7 downto 0);
      ds_axi_awsize   => ds_axi_awsize,   -- out   std_logic_vector(2 downto 0);
      ds_axi_awburst  => ds_axi_awburst,  -- out   std_logic_vector(1 downto 0);
      ds_axi_awcache  => ds_axi_awcache,  -- out   std_logic_vector(3 downto 0);
      ds_axi_awprot   => ds_axi_awprot,   -- out   std_logic_vector(2 downto 0);
      ds_axi_awvalid  => ds_axi_awvalid,  -- out   std_logic;
      ds_axi_wdata    => ds_axi_wdata,    -- out   std_logic_vector(255 downto 0);
      ds_axi_wstrb    => ds_axi_wstrb,    -- out   std_logic_vector(31 downto 0);
      ds_axi_wlast    => ds_axi_wlast,    -- out   std_logic;
      ds_axi_wvalid   => ds_axi_wvalid,   -- out   std_logic;
      ds_axi_bready   => ds_axi_bready,   -- out   std_logic;
      ds_axi_araddr   => ds_axi_araddr,   -- out   std_logic_vector(63 downto 0);
      ds_axi_arlen    => ds_axi_arlen,    -- out   std_logic_vector(7 downto 0);
      ds_axi_arsize   => ds_axi_arsize,   -- out   std_logic_vector(2 downto 0);
      ds_axi_arburst  => ds_axi_arburst,  -- out   std_logic_vector(1 downto 0);
      ds_axi_arcache  => ds_axi_arcache,  -- out   std_logic_vector(3 downto 0);
      ds_axi_arprot   => ds_axi_arprot,   -- out   std_logic_vector(2 downto 0);
      ds_axi_arvalid  => ds_axi_arvalid,  -- out   std_logic;
      ds_axi_rready   => ds_axi_rready,   -- out   std_logic;
      ds_axi_awready  => ds_axi_awready,  -- in    std_logic;
      ds_axi_wready   => ds_axi_wready,   -- in    std_logic;
      ds_axi_bresp    => ds_axi_bresp,    -- in    std_logic_vector(1 downto 0);
      ds_axi_bvalid   => ds_axi_bvalid,   -- in    std_logic;
      ds_axi_arready  => ds_axi_arready,  -- in    std_logic;
      ds_axi_rdata    => ds_axi_rdata,    -- in    std_logic_vector(255 downto 0);
      ds_axi_rresp    => ds_axi_rresp,    -- in    std_logic_vector(1 downto 0);
      ds_axi_rlast    => ds_axi_rlast,    -- in    std_logic;
      ds_axi_rvalid   => ds_axi_rvalid,   -- in    std_logic;
      ds_axi_awlock   => ds_axi_awlock,   -- out   std_logic_vector(0 downto 0);
      ds_axi_awqos    => ds_axi_awqos,    -- out   std_logic_vector(3 downto 0);
      ds_axi_arlock   => ds_axi_arlock,   -- out   std_logic_vector(0 downto 0);
      ds_axi_arqos    => ds_axi_arqos,    -- out   std_logic_vector(3 downto 0);
      ds_axi_awregion => ds_axi_awregion, -- out   std_logic_vector(3 downto 0);
      ds_axi_arregion => ds_axi_arregion, -- out   std_logic_vector(3 downto 0);
      --
      dma0_axi_awaddr   => dma0_axi_awaddr,
      dma0_axi_awlen    => dma0_axi_awlen,
      dma0_axi_awsize   => dma0_axi_awsize,
      dma0_axi_awburst  => dma0_axi_awburst,
      dma0_axi_awcache  => dma0_axi_awcache,
      dma0_axi_awprot   => dma0_axi_awprot,
      dma0_axi_awvalid  => dma0_axi_awvalid,
      dma0_axi_wdata    => dma0_axi_wdata,
      dma0_axi_wstrb    => dma0_axi_wstrb,
      dma0_axi_wlast    => dma0_axi_wlast,
      dma0_axi_wvalid   => dma0_axi_wvalid,
      dma0_axi_bready   => dma0_axi_bready,
      dma0_axi_araddr   => dma0_axi_araddr,
      dma0_axi_arlen    => dma0_axi_arlen,
      dma0_axi_arsize   => dma0_axi_arsize,
      dma0_axi_arburst  => dma0_axi_arburst,
      dma0_axi_arcache  => dma0_axi_arcache,
      dma0_axi_arprot   => dma0_axi_arprot,
      dma0_axi_arvalid  => dma0_axi_arvalid,
      dma0_axi_rready   => dma0_axi_rready,
      dma0_axi_awready  => dma0_axi_awready,
      dma0_axi_wready   => dma0_axi_wready,
      dma0_axi_bresp    => dma0_axi_bresp,
      dma0_axi_bvalid   => dma0_axi_bvalid,
      dma0_axi_arready  => dma0_axi_arready,
      dma0_axi_rdata    => dma0_axi_rdata,
      dma0_axi_rresp    => dma0_axi_rresp,
      dma0_axi_rlast    => dma0_axi_rlast,
      dma0_axi_rvalid   => dma0_axi_rvalid,
      dma0_axi_awlock   => dma0_axi_awlock,
      dma0_axi_awqos    => dma0_axi_awqos,
      dma0_axi_arlock   => dma0_axi_arlock,
      dma0_axi_arqos    => dma0_axi_arqos,
      dma0_axi_awregion => dma0_axi_awregion,
      dma0_axi_arregion => dma0_axi_arregion,
      --
      dma1_axi_awaddr   => dma1_axi_awaddr,
      dma1_axi_awlen    => dma1_axi_awlen,
      dma1_axi_awsize   => dma1_axi_awsize,
      dma1_axi_awburst  => dma1_axi_awburst,
      dma1_axi_awcache  => dma1_axi_awcache,
      dma1_axi_awprot   => dma1_axi_awprot,
      dma1_axi_awvalid  => dma1_axi_awvalid,
      dma1_axi_wdata    => dma1_axi_wdata,
      dma1_axi_wstrb    => dma1_axi_wstrb,
      dma1_axi_wlast    => dma1_axi_wlast,
      dma1_axi_wvalid   => dma1_axi_wvalid,
      dma1_axi_bready   => dma1_axi_bready,
      dma1_axi_araddr   => dma1_axi_araddr,
      dma1_axi_arlen    => dma1_axi_arlen,
      dma1_axi_arsize   => dma1_axi_arsize,
      dma1_axi_arburst  => dma1_axi_arburst,
      dma1_axi_arcache  => dma1_axi_arcache,
      dma1_axi_arprot   => dma1_axi_arprot,
      dma1_axi_arvalid  => dma1_axi_arvalid,
      dma1_axi_rready   => dma1_axi_rready,
      dma1_axi_awready  => dma1_axi_awready,
      dma1_axi_wready   => dma1_axi_wready,
      dma1_axi_bresp    => dma1_axi_bresp,
      dma1_axi_bvalid   => dma1_axi_bvalid,
      dma1_axi_arready  => dma1_axi_arready,
      dma1_axi_rdata    => dma1_axi_rdata,
      dma1_axi_rresp    => dma1_axi_rresp,
      dma1_axi_rlast    => dma1_axi_rlast,
      dma1_axi_rvalid   => dma1_axi_rvalid,
      dma1_axi_awlock   => dma1_axi_awlock,
      dma1_axi_awqos    => dma1_axi_awqos,
      dma1_axi_arlock   => dma1_axi_arlock,
      dma1_axi_arqos    => dma1_axi_arqos,
      dma1_axi_awregion => dma1_axi_awregion,
      dma1_axi_arregion => dma1_axi_arregion,
      --
      dma2_axi_awaddr   => dma2_axi_awaddr,
      dma2_axi_awlen    => dma2_axi_awlen,
      dma2_axi_awsize   => dma2_axi_awsize,
      dma2_axi_awburst  => dma2_axi_awburst,
      dma2_axi_awcache  => dma2_axi_awcache,
      dma2_axi_awprot   => dma2_axi_awprot,
      dma2_axi_awvalid  => dma2_axi_awvalid,
      dma2_axi_wdata    => dma2_axi_wdata,
      dma2_axi_wstrb    => dma2_axi_wstrb,
      dma2_axi_wlast    => dma2_axi_wlast,
      dma2_axi_wvalid   => dma2_axi_wvalid,
      dma2_axi_bready   => dma2_axi_bready,
      dma2_axi_araddr   => dma2_axi_araddr,
      dma2_axi_arlen    => dma2_axi_arlen,
      dma2_axi_arsize   => dma2_axi_arsize,
      dma2_axi_arburst  => dma2_axi_arburst,
      dma2_axi_arcache  => dma2_axi_arcache,
      dma2_axi_arprot   => dma2_axi_arprot,
      dma2_axi_arvalid  => dma2_axi_arvalid,
      dma2_axi_rready   => dma2_axi_rready,
      dma2_axi_awready  => dma2_axi_awready,
      dma2_axi_wready   => dma2_axi_wready,
      dma2_axi_bresp    => dma2_axi_bresp,
      dma2_axi_bvalid   => dma2_axi_bvalid,
      dma2_axi_arready  => dma2_axi_arready,
      dma2_axi_rdata    => dma2_axi_rdata,
      dma2_axi_rresp    => dma2_axi_rresp,
      dma2_axi_rlast    => dma2_axi_rlast,
      dma2_axi_rvalid   => dma2_axi_rvalid,
      dma2_axi_awlock   => dma2_axi_awlock,
      dma2_axi_awqos    => dma2_axi_awqos,
      dma2_axi_arlock   => dma2_axi_arlock,
      dma2_axi_arqos    => dma2_axi_arqos,
      dma2_axi_awregion => dma2_axi_awregion,
      dma2_axi_arregion => dma2_axi_arregion,
      --
      dma3_axi_awaddr   => dma3_axi_awaddr,
      dma3_axi_awlen    => dma3_axi_awlen,
      dma3_axi_awsize   => dma3_axi_awsize,
      dma3_axi_awburst  => dma3_axi_awburst,
      dma3_axi_awcache  => dma3_axi_awcache,
      dma3_axi_awprot   => dma3_axi_awprot,
      dma3_axi_awvalid  => dma3_axi_awvalid,
      dma3_axi_wdata    => dma3_axi_wdata,
      dma3_axi_wstrb    => dma3_axi_wstrb,
      dma3_axi_wlast    => dma3_axi_wlast,
      dma3_axi_wvalid   => dma3_axi_wvalid,
      dma3_axi_bready   => dma3_axi_bready,
      dma3_axi_araddr   => dma3_axi_araddr,
      dma3_axi_arlen    => dma3_axi_arlen,
      dma3_axi_arsize   => dma3_axi_arsize,
      dma3_axi_arburst  => dma3_axi_arburst,
      dma3_axi_arcache  => dma3_axi_arcache,
      dma3_axi_arprot   => dma3_axi_arprot,
      dma3_axi_arvalid  => dma3_axi_arvalid,
      dma3_axi_rready   => dma3_axi_rready,
      dma3_axi_awready  => dma3_axi_awready,
      dma3_axi_wready   => dma3_axi_wready,
      dma3_axi_bresp    => dma3_axi_bresp,
      dma3_axi_bvalid   => dma3_axi_bvalid,
      dma3_axi_arready  => dma3_axi_arready,
      dma3_axi_rdata    => dma3_axi_rdata,
      dma3_axi_rresp    => dma3_axi_rresp,
      dma3_axi_rlast    => dma3_axi_rlast,
      dma3_axi_rvalid   => dma3_axi_rvalid,
      dma3_axi_awlock   => dma3_axi_awlock,
      dma3_axi_awqos    => dma3_axi_awqos,
      dma3_axi_arlock   => dma3_axi_arlock,
      dma3_axi_arqos    => dma3_axi_arqos,
      dma3_axi_awregion => dma3_axi_awregion,
      dma3_axi_arregion => dma3_axi_arregion,
      --
      core_status => core_status);
  end generate;


  adb3_admxrcku1_sim_g : if (sim_axi = true) generate
    component adb3_admxrcku1_sim
    port(
      refclk300_p  : in    std_logic;
      refclk300_n  : in    std_logic;
      refclk       : out   std_logic;
      --
      perst_n     : in    std_logic;
      pcie100_p   : in    std_logic;
      pcie100_n   : in    std_logic;
      pci_exp_txn : out   std_logic_vector(7 downto 0);
      pci_exp_txp : out   std_logic_vector(7 downto 0);
      pci_exp_rxn : in    std_logic_vector(7 downto 0);
      pci_exp_rxp : in    std_logic_vector(7 downto 0);
      --
      vpd_out : out   std_logic_vector(47 downto 0);
      --
      avr_clk : in    std_logic;
      avr_b2t : in    std_logic;
      avr_t2b : out   std_logic;
      --
      aclk    : out   std_logic;
      aresetn : out   std_logic;
      --
      ds_axi_awaddr   : out   std_logic_vector(63 downto 0);
      ds_axi_awlen    : out   std_logic_vector(7 downto 0);
      ds_axi_awsize   : out   std_logic_vector(2 downto 0);
      ds_axi_awburst  : out   std_logic_vector(1 downto 0);
      ds_axi_awcache  : out   std_logic_vector(3 downto 0);
      ds_axi_awprot   : out   std_logic_vector(2 downto 0);
      ds_axi_awvalid  : out   std_logic;
      ds_axi_wdata    : out   std_logic_vector(255 downto 0);
      ds_axi_wstrb    : out   std_logic_vector(31 downto 0);
      ds_axi_wlast    : out   std_logic;
      ds_axi_wvalid   : out   std_logic;
      ds_axi_bready   : out   std_logic;
      ds_axi_araddr   : out   std_logic_vector(63 downto 0);
      ds_axi_arlen    : out   std_logic_vector(7 downto 0);
      ds_axi_arsize   : out   std_logic_vector(2 downto 0);
      ds_axi_arburst  : out   std_logic_vector(1 downto 0);
      ds_axi_arcache  : out   std_logic_vector(3 downto 0);
      ds_axi_arprot   : out   std_logic_vector(2 downto 0);
      ds_axi_arvalid  : out   std_logic;
      ds_axi_rready   : out   std_logic;
      ds_axi_awready  : in    std_logic;
      ds_axi_wready   : in    std_logic;
      ds_axi_bresp    : in    std_logic_vector(1 downto 0);
      ds_axi_bvalid   : in    std_logic;
      ds_axi_arready  : in    std_logic;
      ds_axi_rdata    : in    std_logic_vector(255 downto 0);
      ds_axi_rresp    : in    std_logic_vector(1 downto 0);
      ds_axi_rlast    : in    std_logic;
      ds_axi_rvalid   : in    std_logic;
      ds_axi_awlock   : out   std_logic_vector(0 downto 0);
      ds_axi_awqos    : out   std_logic_vector(3 downto 0);
      ds_axi_arlock   : out   std_logic_vector(0 downto 0);
      ds_axi_arqos    : out   std_logic_vector(3 downto 0);
      ds_axi_awregion : out   std_logic_vector(3 downto 0);
      ds_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma0_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma0_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma0_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma0_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma0_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma0_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma0_axi_awvalid  : out   std_logic;
      dma0_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma0_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma0_axi_wlast    : out   std_logic;
      dma0_axi_wvalid   : out   std_logic;
      dma0_axi_bready   : out   std_logic;
      dma0_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma0_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma0_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma0_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma0_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma0_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma0_axi_arvalid  : out   std_logic;
      dma0_axi_rready   : out   std_logic;
      dma0_axi_awready  : in    std_logic;
      dma0_axi_wready   : in    std_logic;
      dma0_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma0_axi_bvalid   : in    std_logic;
      dma0_axi_arready  : in    std_logic;
      dma0_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma0_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma0_axi_rlast    : in    std_logic;
      dma0_axi_rvalid   : in    std_logic;
      dma0_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma0_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma0_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma0_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma0_axi_awregion : out   std_logic_vector(3 downto 0);
      dma0_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma1_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma1_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma1_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma1_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma1_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma1_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma1_axi_awvalid  : out   std_logic;
      dma1_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma1_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma1_axi_wlast    : out   std_logic;
      dma1_axi_wvalid   : out   std_logic;
      dma1_axi_bready   : out   std_logic;
      dma1_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma1_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma1_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma1_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma1_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma1_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma1_axi_arvalid  : out   std_logic;
      dma1_axi_rready   : out   std_logic;
      dma1_axi_awready  : in    std_logic;
      dma1_axi_wready   : in    std_logic;
      dma1_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma1_axi_bvalid   : in    std_logic;
      dma1_axi_arready  : in    std_logic;
      dma1_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma1_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma1_axi_rlast    : in    std_logic;
      dma1_axi_rvalid   : in    std_logic;
      dma1_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma1_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma1_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma1_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma1_axi_awregion : out   std_logic_vector(3 downto 0);
      dma1_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma2_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma2_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma2_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma2_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma2_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma2_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma2_axi_awvalid  : out   std_logic;
      dma2_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma2_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma2_axi_wlast    : out   std_logic;
      dma2_axi_wvalid   : out   std_logic;
      dma2_axi_bready   : out   std_logic;
      dma2_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma2_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma2_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma2_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma2_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma2_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma2_axi_arvalid  : out   std_logic;
      dma2_axi_rready   : out   std_logic;
      dma2_axi_awready  : in    std_logic;
      dma2_axi_wready   : in    std_logic;
      dma2_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma2_axi_bvalid   : in    std_logic;
      dma2_axi_arready  : in    std_logic;
      dma2_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma2_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma2_axi_rlast    : in    std_logic;
      dma2_axi_rvalid   : in    std_logic;
      dma2_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma2_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma2_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma2_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma2_axi_awregion : out   std_logic_vector(3 downto 0);
      dma2_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      dma3_axi_awaddr   : out   std_logic_vector(38 downto 0);
      dma3_axi_awlen    : out   std_logic_vector(7 downto 0);
      dma3_axi_awsize   : out   std_logic_vector(2 downto 0);
      dma3_axi_awburst  : out   std_logic_vector(1 downto 0);
      dma3_axi_awcache  : out   std_logic_vector(3 downto 0);
      dma3_axi_awprot   : out   std_logic_vector(2 downto 0);
      dma3_axi_awvalid  : out   std_logic;
      dma3_axi_wdata    : out   std_logic_vector(255 downto 0);
      dma3_axi_wstrb    : out   std_logic_vector(31 downto 0);
      dma3_axi_wlast    : out   std_logic;
      dma3_axi_wvalid   : out   std_logic;
      dma3_axi_bready   : out   std_logic;
      dma3_axi_araddr   : out   std_logic_vector(38 downto 0);
      dma3_axi_arlen    : out   std_logic_vector(7 downto 0);
      dma3_axi_arsize   : out   std_logic_vector(2 downto 0);
      dma3_axi_arburst  : out   std_logic_vector(1 downto 0);
      dma3_axi_arcache  : out   std_logic_vector(3 downto 0);
      dma3_axi_arprot   : out   std_logic_vector(2 downto 0);
      dma3_axi_arvalid  : out   std_logic;
      dma3_axi_rready   : out   std_logic;
      dma3_axi_awready  : in    std_logic;
      dma3_axi_wready   : in    std_logic;
      dma3_axi_bresp    : in    std_logic_vector(1 downto 0);
      dma3_axi_bvalid   : in    std_logic;
      dma3_axi_arready  : in    std_logic;
      dma3_axi_rdata    : in    std_logic_vector(255 downto 0);
      dma3_axi_rresp    : in    std_logic_vector(1 downto 0);
      dma3_axi_rlast    : in    std_logic;
      dma3_axi_rvalid   : in    std_logic;
      dma3_axi_awlock   : out   std_logic_vector(0 downto 0);
      dma3_axi_awqos    : out   std_logic_vector(3 downto 0);
      dma3_axi_arlock   : out   std_logic_vector(0 downto 0);
      dma3_axi_arqos    : out   std_logic_vector(3 downto 0);
      dma3_axi_awregion : out   std_logic_vector(3 downto 0);
      dma3_axi_arregion : out   std_logic_vector(3 downto 0);
      --
      core_status : out   std_logic_vector(63 downto 0));
    end component;
  begin
    -- AXI simulation 
    adb3_admxrcku1_sim_i : adb3_admxrcku1_sim
    port map(
      refclk300_p  => refclk300_p,  -- in    std_logic
      refclk300_n  => refclk300_n,  -- in    std_logic
      refclk       => refclk,       -- out   std_logic
      --
      perst_n     => perst_n,   --  in    std_logic
      pcie100_p   => pcie100_p, --  in    std_logic
      pcie100_n   => pcie100_n, --  in    std_logic
      pci_exp_txn => pci_t2h_n, --  out   std_logic_vector(7 downto 0)
      pci_exp_txp => pci_t2h_p, --  out   std_logic_vector(7 downto 0)
      pci_exp_rxn => pci_h2t_n, --  in    std_logic_vector(7 downto 0)
      pci_exp_rxp => pci_h2t_p, --  in    std_logic_vector(7 downto 0)
      --
      vpd_out => vpd_out, -- out   std_logic_vector(47 downto 0)
      --
      avr_clk => avr_clk, -- in    std_logic;
      avr_b2t => avr_b2t, -- in    std_logic;
      avr_t2b => avr_t2b, -- out   std_logic;
      --
      aclk    => aclk,    -- out   std_logic;
      aresetn => aresetn, -- out   std_logic;
      --
      ds_axi_awaddr   => ds_axi_awaddr,   -- out   std_logic_vector(63 downto 0);
      ds_axi_awlen    => ds_axi_awlen,    -- out   std_logic_vector(7 downto 0);
      ds_axi_awsize   => ds_axi_awsize,   -- out   std_logic_vector(2 downto 0);
      ds_axi_awburst  => ds_axi_awburst,  -- out   std_logic_vector(1 downto 0);
      ds_axi_awcache  => ds_axi_awcache,  -- out   std_logic_vector(3 downto 0);
      ds_axi_awprot   => ds_axi_awprot,   -- out   std_logic_vector(2 downto 0);
      ds_axi_awvalid  => ds_axi_awvalid,  -- out   std_logic;
      ds_axi_wdata    => ds_axi_wdata,    -- out   std_logic_vector(255 downto 0);
      ds_axi_wstrb    => ds_axi_wstrb,    -- out   std_logic_vector(31 downto 0);
      ds_axi_wlast    => ds_axi_wlast,    -- out   std_logic;
      ds_axi_wvalid   => ds_axi_wvalid,   -- out   std_logic;
      ds_axi_bready   => ds_axi_bready,   -- out   std_logic;
      ds_axi_araddr   => ds_axi_araddr,   -- out   std_logic_vector(63 downto 0);
      ds_axi_arlen    => ds_axi_arlen,    -- out   std_logic_vector(7 downto 0);
      ds_axi_arsize   => ds_axi_arsize,   -- out   std_logic_vector(2 downto 0);
      ds_axi_arburst  => ds_axi_arburst,  -- out   std_logic_vector(1 downto 0);
      ds_axi_arcache  => ds_axi_arcache,  -- out   std_logic_vector(3 downto 0);
      ds_axi_arprot   => ds_axi_arprot,   -- out   std_logic_vector(2 downto 0);
      ds_axi_arvalid  => ds_axi_arvalid,  -- out   std_logic;
      ds_axi_rready   => ds_axi_rready,   -- out   std_logic;
      ds_axi_awready  => ds_axi_awready,  -- in    std_logic;
      ds_axi_wready   => ds_axi_wready,   -- in    std_logic;
      ds_axi_bresp    => ds_axi_bresp,    -- in    std_logic_vector(1 downto 0);
      ds_axi_bvalid   => ds_axi_bvalid,   -- in    std_logic;
      ds_axi_arready  => ds_axi_arready,  -- in    std_logic;
      ds_axi_rdata    => ds_axi_rdata,    -- in    std_logic_vector(255 downto 0);
      ds_axi_rresp    => ds_axi_rresp,    -- in    std_logic_vector(1 downto 0);
      ds_axi_rlast    => ds_axi_rlast,    -- in    std_logic;
      ds_axi_rvalid   => ds_axi_rvalid,   -- in    std_logic;
      ds_axi_awlock   => ds_axi_awlock,   -- out   std_logic_vector(0 downto 0);
      ds_axi_awqos    => ds_axi_awqos,    -- out   std_logic_vector(3 downto 0);
      ds_axi_arlock   => ds_axi_arlock,   -- out   std_logic_vector(0 downto 0);
      ds_axi_arqos    => ds_axi_arqos,    -- out   std_logic_vector(3 downto 0);
      ds_axi_awregion => ds_axi_awregion, -- out   std_logic_vector(3 downto 0);
      ds_axi_arregion => ds_axi_arregion, -- out   std_logic_vector(3 downto 0);
      --
      dma0_axi_awaddr   => dma0_axi_awaddr,
      dma0_axi_awlen    => dma0_axi_awlen,
      dma0_axi_awsize   => dma0_axi_awsize,
      dma0_axi_awburst  => dma0_axi_awburst,
      dma0_axi_awcache  => dma0_axi_awcache,
      dma0_axi_awprot   => dma0_axi_awprot,
      dma0_axi_awvalid  => dma0_axi_awvalid,
      dma0_axi_wdata    => dma0_axi_wdata,
      dma0_axi_wstrb    => dma0_axi_wstrb,
      dma0_axi_wlast    => dma0_axi_wlast,
      dma0_axi_wvalid   => dma0_axi_wvalid,
      dma0_axi_bready   => dma0_axi_bready,
      dma0_axi_araddr   => dma0_axi_araddr,
      dma0_axi_arlen    => dma0_axi_arlen,
      dma0_axi_arsize   => dma0_axi_arsize,
      dma0_axi_arburst  => dma0_axi_arburst,
      dma0_axi_arcache  => dma0_axi_arcache,
      dma0_axi_arprot   => dma0_axi_arprot,
      dma0_axi_arvalid  => dma0_axi_arvalid,
      dma0_axi_rready   => dma0_axi_rready,
      dma0_axi_awready  => dma0_axi_awready,
      dma0_axi_wready   => dma0_axi_wready,
      dma0_axi_bresp    => dma0_axi_bresp,
      dma0_axi_bvalid   => dma0_axi_bvalid,
      dma0_axi_arready  => dma0_axi_arready,
      dma0_axi_rdata    => dma0_axi_rdata,
      dma0_axi_rresp    => dma0_axi_rresp,
      dma0_axi_rlast    => dma0_axi_rlast,
      dma0_axi_rvalid   => dma0_axi_rvalid,
      dma0_axi_awlock   => dma0_axi_awlock,
      dma0_axi_awqos    => dma0_axi_awqos,
      dma0_axi_arlock   => dma0_axi_arlock,
      dma0_axi_arqos    => dma0_axi_arqos,
      dma0_axi_awregion => dma0_axi_awregion,
      dma0_axi_arregion => dma0_axi_arregion,
      --
      dma1_axi_awaddr   => dma1_axi_awaddr,
      dma1_axi_awlen    => dma1_axi_awlen,
      dma1_axi_awsize   => dma1_axi_awsize,
      dma1_axi_awburst  => dma1_axi_awburst,
      dma1_axi_awcache  => dma1_axi_awcache,
      dma1_axi_awprot   => dma1_axi_awprot,
      dma1_axi_awvalid  => dma1_axi_awvalid,
      dma1_axi_wdata    => dma1_axi_wdata,
      dma1_axi_wstrb    => dma1_axi_wstrb,
      dma1_axi_wlast    => dma1_axi_wlast,
      dma1_axi_wvalid   => dma1_axi_wvalid,
      dma1_axi_bready   => dma1_axi_bready,
      dma1_axi_araddr   => dma1_axi_araddr,
      dma1_axi_arlen    => dma1_axi_arlen,
      dma1_axi_arsize   => dma1_axi_arsize,
      dma1_axi_arburst  => dma1_axi_arburst,
      dma1_axi_arcache  => dma1_axi_arcache,
      dma1_axi_arprot   => dma1_axi_arprot,
      dma1_axi_arvalid  => dma1_axi_arvalid,
      dma1_axi_rready   => dma1_axi_rready,
      dma1_axi_awready  => dma1_axi_awready,
      dma1_axi_wready   => dma1_axi_wready,
      dma1_axi_bresp    => dma1_axi_bresp,
      dma1_axi_bvalid   => dma1_axi_bvalid,
      dma1_axi_arready  => dma1_axi_arready,
      dma1_axi_rdata    => dma1_axi_rdata,
      dma1_axi_rresp    => dma1_axi_rresp,
      dma1_axi_rlast    => dma1_axi_rlast,
      dma1_axi_rvalid   => dma1_axi_rvalid,
      dma1_axi_awlock   => dma1_axi_awlock,
      dma1_axi_awqos    => dma1_axi_awqos,
      dma1_axi_arlock   => dma1_axi_arlock,
      dma1_axi_arqos    => dma1_axi_arqos,
      dma1_axi_awregion => dma1_axi_awregion,
      dma1_axi_arregion => dma1_axi_arregion,
      --
      dma2_axi_awaddr   => dma2_axi_awaddr,
      dma2_axi_awlen    => dma2_axi_awlen,
      dma2_axi_awsize   => dma2_axi_awsize,
      dma2_axi_awburst  => dma2_axi_awburst,
      dma2_axi_awcache  => dma2_axi_awcache,
      dma2_axi_awprot   => dma2_axi_awprot,
      dma2_axi_awvalid  => dma2_axi_awvalid,
      dma2_axi_wdata    => dma2_axi_wdata,
      dma2_axi_wstrb    => dma2_axi_wstrb,
      dma2_axi_wlast    => dma2_axi_wlast,
      dma2_axi_wvalid   => dma2_axi_wvalid,
      dma2_axi_bready   => dma2_axi_bready,
      dma2_axi_araddr   => dma2_axi_araddr,
      dma2_axi_arlen    => dma2_axi_arlen,
      dma2_axi_arsize   => dma2_axi_arsize,
      dma2_axi_arburst  => dma2_axi_arburst,
      dma2_axi_arcache  => dma2_axi_arcache,
      dma2_axi_arprot   => dma2_axi_arprot,
      dma2_axi_arvalid  => dma2_axi_arvalid,
      dma2_axi_rready   => dma2_axi_rready,
      dma2_axi_awready  => dma2_axi_awready,
      dma2_axi_wready   => dma2_axi_wready,
      dma2_axi_bresp    => dma2_axi_bresp,
      dma2_axi_bvalid   => dma2_axi_bvalid,
      dma2_axi_arready  => dma2_axi_arready,
      dma2_axi_rdata    => dma2_axi_rdata,
      dma2_axi_rresp    => dma2_axi_rresp,
      dma2_axi_rlast    => dma2_axi_rlast,
      dma2_axi_rvalid   => dma2_axi_rvalid,
      dma2_axi_awlock   => dma2_axi_awlock,
      dma2_axi_awqos    => dma2_axi_awqos,
      dma2_axi_arlock   => dma2_axi_arlock,
      dma2_axi_arqos    => dma2_axi_arqos,
      dma2_axi_awregion => dma2_axi_awregion,
      dma2_axi_arregion => dma2_axi_arregion,
      --
      dma3_axi_awaddr   => dma3_axi_awaddr,
      dma3_axi_awlen    => dma3_axi_awlen,
      dma3_axi_awsize   => dma3_axi_awsize,
      dma3_axi_awburst  => dma3_axi_awburst,
      dma3_axi_awcache  => dma3_axi_awcache,
      dma3_axi_awprot   => dma3_axi_awprot,
      dma3_axi_awvalid  => dma3_axi_awvalid,
      dma3_axi_wdata    => dma3_axi_wdata,
      dma3_axi_wstrb    => dma3_axi_wstrb,
      dma3_axi_wlast    => dma3_axi_wlast,
      dma3_axi_wvalid   => dma3_axi_wvalid,
      dma3_axi_bready   => dma3_axi_bready,
      dma3_axi_araddr   => dma3_axi_araddr,
      dma3_axi_arlen    => dma3_axi_arlen,
      dma3_axi_arsize   => dma3_axi_arsize,
      dma3_axi_arburst  => dma3_axi_arburst,
      dma3_axi_arcache  => dma3_axi_arcache,
      dma3_axi_arprot   => dma3_axi_arprot,
      dma3_axi_arvalid  => dma3_axi_arvalid,
      dma3_axi_rready   => dma3_axi_rready,
      dma3_axi_awready  => dma3_axi_awready,
      dma3_axi_wready   => dma3_axi_wready,
      dma3_axi_bresp    => dma3_axi_bresp,
      dma3_axi_bvalid   => dma3_axi_bvalid,
      dma3_axi_arready  => dma3_axi_arready,
      dma3_axi_rdata    => dma3_axi_rdata,
      dma3_axi_rresp    => dma3_axi_rresp,
      dma3_axi_rlast    => dma3_axi_rlast,
      dma3_axi_rvalid   => dma3_axi_rvalid,
      dma3_axi_awlock   => dma3_axi_awlock,
      dma3_axi_awqos    => dma3_axi_awqos,
      dma3_axi_arlock   => dma3_axi_arlock,
      dma3_axi_arqos    => dma3_axi_arqos,
      dma3_axi_awregion => dma3_axi_awregion,
      dma3_axi_arregion => dma3_axi_arregion,
      --
      core_status => core_status);
  end generate;

end;