set VAR_SIM_AXI     [get_value /tb_simple/sim_axi]
set VAR_SER_WIDTH   [get_value /tb_simple/MPTL_SER_WIDTH]
set VAR_MODEL       [get_value /tb_simple/MODEL_NAME]

if $VAR_SIM_AXI then {
  set VAR_SIM "sim_axi"
} else {
  set VAR_SIM "sim_mptl"
}

set wave_pat {
/tb_simple
/tb_simple/uut
}

close_wave_config -force
create_wave_config -name "simple (AXI) (${VAR_MODEL}, MPTLx${VAR_SER_WIDTH}, ${VAR_SIM})"

foreach pattern $wave_pat {
  add_wave_group $pattern
  add_wave -into $pattern -radix hex $pattern
}

set NumericStdNoWarnings 1
set StdArithNoWarnings 1

set run_list [get_property {xsim.simulate.runtime} [current_fileset -simset]]
run [lindex $run_list 0] [lindex $run_list 1]
