##-----------------------------------------------------------------------------
##
## (c) Copyright 2012-2012 Xilinx, Inc. All rights reserved.
##
## This file contains confidential and proprietary information
## of Xilinx, Inc. and is protected under U.S. and
## international copyright and other intellectual property
## laws.
##
## DISCLAIMER
## This disclaimer is not a license and does not grant any
## rights to the materials distributed herewith. Except as
## otherwise provided in a valid license issued to you by
## Xilinx, and to the maximum extent permitted by applicable
## law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
## WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
## AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
## BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
## INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
## (2) Xilinx shall not be liable (whether in contract or tort,
## including negligence, or under any other theory of
## liability) for any loss or damage of any kind or nature
## related to, arising under or in connection with these
## materials, including for any direct, or any indirect,
## special, incidental, or consequential loss or damage
## (including loss of data, profits, goodwill, or any type of
## loss or damage suffered as a result of any action brought
## by a third party) even if such damage or loss was
## reasonably foreseeable or Xilinx had been advised of the
## possibility of the same.
##
## CRITICAL APPLICATIONS
## Xilinx products are not designed or intended to be fail-
## safe, or for use in any application requiring fail-safe
## performance, such as life-support or safety devices or
## systems, Class III medical devices, nuclear facilities,
## applications related to the deployment of airbags, or any
## other applications that could lead to death, personal
## injury, or severe property or environmental damage
## (individually and collectively, "Critical
## Applications"). Customer assumes the sole risk and
## liability of any use of Xilinx products in Critical
## Applications, subject only to applicable laws and
## regulations governing limitations on product liability.
##
## THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
## PART OF THIS FILE AT ALL TIMES.
##
##-----------------------------------------------------------------------------


create_clock -name sys_clkb -period 10 [get_ports pcie100_1_clk_p]

set_property max_fanout 50 [get_nets *]

###############################################################################
# Physical Constraints
###############################################################################
###############################################################################
#
# PCI Express Block placement. This constraint selects the PCI Express
# Block to be used.
#
###############################################################################
set_property LOC PCIE_3_1_X0Y1 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/PCIE_3_1_inst}]

###############################################################################
# Buffer (BRAM) Placement Constraints
###############################################################################

#Request Buffer RAMB Placement

set_property LOC RAMB18_X16Y74 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_8k_inst/RAMB18E2[0].ramb18e2_inst}]
set_property LOC RAMB18_X16Y75 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_8k_inst/RAMB18E2[1].ramb18e2_inst}]
set_property LOC RAMB18_X16Y76 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_8k_inst/RAMB18E2[2].ramb18e2_inst}]
set_property LOC RAMB18_X16Y77 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_req_inst/bram_8k_inst/RAMB18E2[3].ramb18e2_inst}]

# Completion Buffer RAMB Placement

set_property LOC RAMB18_X16Y80 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[0].ramb18e2_inst}]
set_property LOC RAMB18_X16Y81 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[1].ramb18e2_inst}]
set_property LOC RAMB18_X16Y82 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[2].ramb18e2_inst}]
set_property LOC RAMB18_X16Y83 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[3].ramb18e2_inst}]
set_property LOC RAMB18_X16Y84 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[4].ramb18e2_inst}]
set_property LOC RAMB18_X16Y85 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[5].ramb18e2_inst}]
set_property LOC RAMB18_X16Y86 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[6].ramb18e2_inst}]
set_property LOC RAMB18_X16Y87 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_cpl_inst/CPL_FIFO_16KB.bram_16k_inst/RAMB18E2[7].ramb18e2_inst}]


# Replay Buffer RAMB Placement
set_property LOC RAMB36_X16Y45 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_rep_inst/bram_rep_8k_inst/RAMB36E2[0].ramb36e2_inst}]
set_property LOC RAMB36_X16Y46 [get_cells -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/pcie3_uscale_top_inst/pcie3_uscale_wrapper_inst/bram_inst/bram_rep_inst/bram_rep_8k_inst/RAMB36E2[1].ramb36e2_inst}]


###############################################################################
# Timing Constraints
###############################################################################
#




# Set Divide By 2
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_userclk/DIV[2]}]
# Set Divide By 2
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_pclk/DIV[2]}]
# Set Divide By 4
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[0]}]
set_case_analysis 1 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/bufg_mcap_clk/DIV[2]}]
# Set Divide By 1
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[0]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[1]}]
set_case_analysis 0 [get_pins  -hier -filter {NAME =~ *adb3_core_bridge_2/pcie3_7x_0_wrapper_1/pcie_core_i/inst/gt_top_i/phy_clk_i/bufg_gt_coreclk/DIV[2]}]



# UltraScale FPGAs Transceivers Wizard IP core-level XDC file
# ----------------------------------------------------------------------------------------------------------------------

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y8
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y8 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin Y1 [get_ports gthrxn_in[0]]
#set_property package_pin Y2 [get_ports gthrxp_in[0]]
#set_property package_pin AA3 [get_ports gthtxn_out[0]]
#set_property package_pin AA4 [get_ports gthtxp_out[0]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[0].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y9
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y9 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin V1 [get_ports gthrxn_in[1]]
#set_property package_pin V2 [get_ports gthrxp_in[1]]
#set_property package_pin W3 [get_ports gthtxn_out[1]]
#set_property package_pin W4 [get_ports gthtxp_out[1]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[1].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y10
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y10 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin T1 [get_ports gthrxn_in[2]]
#set_property package_pin T2 [get_ports gthrxp_in[2]]
#set_property package_pin U3 [get_ports gthtxn_out[2]]
#set_property package_pin U4 [get_ports gthtxp_out[2]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[2].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y11
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y11 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin P1 [get_ports gthrxn_in[3]]
#set_property package_pin P2 [get_ports gthrxp_in[3]]
#set_property package_pin R3 [get_ports gthtxn_out[3]]
#set_property package_pin R4 [get_ports gthtxp_out[3]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[3].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y12
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y12 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[0].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin M1 [get_ports gthrxn_in[4]]
#set_property package_pin M2 [get_ports gthrxp_in[4]]
#set_property package_pin N3 [get_ports gthtxn_out[4]]
#set_property package_pin N4 [get_ports gthtxp_out[4]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[4].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y13
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y13 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[1].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin K1 [get_ports gthrxn_in[5]]
#set_property package_pin K2 [get_ports gthrxp_in[5]]
#set_property package_pin L3 [get_ports gthtxn_out[5]]
#set_property package_pin L4 [get_ports gthtxp_out[5]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[5].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y14
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y14 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[2].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin H1 [get_ports gthrxn_in[6]]
#set_property package_pin H2 [get_ports gthrxp_in[6]]
#set_property package_pin J3 [get_ports gthtxn_out[6]]
#set_property package_pin J4 [get_ports gthtxp_out[6]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[6].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet

# Commands for enabled transceiver GTHE3_CHANNEL_X1Y15
# ----------------------------------------------------------------------------------------------------------------------

# PCIe-specific TXOUTCLK clock constraint
create_clock -period 2.0 [get_pins -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST/TXOUTCLK}]

# Channel primitive location constraint
set_property LOC GTHE3_CHANNEL_X1Y15 [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[27].*gen_gthe3_channel_inst[3].GTHE3_CHANNEL_PRIM_INST}]

# Channel primitive serial data pin location constraints
# (Provided as comments for your reference. The channel primitive location constraint is sufficient.)
#set_property package_pin F1 [get_ports gthrxn_in[7]]
#set_property package_pin F2 [get_ports gthrxp_in[7]]
#set_property package_pin G3 [get_ports gthtxn_out[7]]
#set_property package_pin G4 [get_ports gthtxp_out[7]]

# CPLL calibration block constraints
create_clock -period 10.0 [get_pins -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*bufg_gt_txoutclkmon_inst/O}]
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/testclk_cnt_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/freq_cnt_o_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/tstclk_rst_dly1_reg*}] -quiet
set_false_path -from [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/state_reg*}] -to [get_cells -hierarchical -filter {NAME =~ *gen_cpll_cal_inst[7].*U_TXOUTCLK_FREQ_COUNTER/testclk_en_dly1_reg*}] -quiet


# False path constraints
# ----------------------------------------------------------------------------------------------------------------------

set_false_path -to [get_cells -hierarchical -filter {NAME =~ *bit_synchronizer*inst/i_in_meta_reg}]
set_false_path -to [get_cells -hierarchical -filter {NAME =~ *reset_synchronizer*inst/rst_in_*_reg}]



set_false_path -from [get_pins -hier -filter {NAME =~*adb3_core_bridge_2/pcie_rst_held*/C}]

set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/CPLLLOCK}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/GTPOWERGOOD}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/PCIESYNCTXSYNCDONE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/TXPRGDIVRESETDONE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gen_gthe3_channel_inst[?].GTHE3_CHANNEL_PRIM_INST/RXELECIDLE}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*gthe3_common_gen.GTHE3_COMMON_PRIM_INST/QPLL1LOCK}]
set_false_path        -through [get_pins        -hier -filter {NAME =~ *pcie_core_i*pcie3_uscale_wrapper_inst/PCIE_3_1_inst/PCIEPERST0B}]
