#ifndef _ADATA_NUM_TOKEN_H
#define _ADATA_NUM_TOKEN_H

#define SAMPLE_TOKEN_MAX_LENGTH (128)

typedef enum _SampleTokenSubstate {
  SampleTokenSubstateIdle,
  SampleTokenSubstateDecimal,
  SampleTokenSubstateHexadecimal,
  SampleTokenSubstateInvalid
} SampleTokenSubstate;

#define SAMPLE_TOKEN_STATUS_TRUNCATED (0x1U << 0)
#define SAMPLE_TOKEN_STATUS_MALFORMED (0x1U << 1)

typedef struct _SampleTokenState {
  unsigned int position;
  SampleTokenSubstate substate;
  /* Valid when sampleTokenPumpState returns TRUE */
  struct {
    unsigned int length;
    unsigned int status; /* See SAMPLE_TOKEN_STATUS_xxx */
    unsigned long long value;
    TCHAR tokenBuf[SAMPLE_TOKEN_MAX_LENGTH];
  } result;
} SampleTokenState;

static const SampleTokenState g_sampleTokenStateInit = {
  0, SampleTokenSubstateIdle
};

#define SAMPLE_TOKEN_FLAG_INTERPRET_HEX       (0x1U << 0) /* Tokens are interpreted as hexadecimal by default */
#define SAMPLE_TOKEN_FLAG_NEWLINE_EMPTY_TOKEN (0x1U << 1) /* Newline can produce empty token */

extern bool_t
sampleTokenPumpState(
  SampleTokenState* pState,
  TCHAR c,
  unsigned int flags);

#endif
