#ifndef _ADATA_PLATFORM_EVENT_H
#define _ADATA_PLATFORM_EVENT_H

#include <windows.h>

#define PORTABLE_EVENT_HANDLE_INVALID_VALUE NULL
typedef HANDLE PortableEventHandle;

typedef enum _PortableEventStatus {
  PortableEventOk = 0,
  PortableEventTimeout = 1,
  PortableEventFailed = 2
} PortableEventStatus;

__inline static PortableEventHandle
portableEventCreate(
  void)
{
  return CreateEvent(NULL, FALSE, FALSE, NULL);
}

__inline static void
portableEventDestroy(
  PortableEventHandle e)
{
  CloseHandle(e);
}

__inline static void
portableEventSignal(
  PortableEventHandle e)
{
  SetEvent(e);
}

__inline static PortableEventStatus
portableEventWait(
  PortableEventHandle e)
{
  DWORD dwRes;

  dwRes = WaitForSingleObject(e, INFINITE);
  if (WAIT_OBJECT_0 == dwRes) {
    return PortableEventOk;
  } else {
    if (WAIT_TIMEOUT == dwRes) {
      return PortableEventTimeout;
    } else {
      return PortableEventFailed;
    }
  }
}

__inline static PortableEventStatus
portableEventWaitTimeout(
  PortableEventHandle e,
  unsigned int timeoutMs)
{
  DWORD dwRes;

  dwRes = WaitForSingleObject(e, timeoutMs);
  if (WAIT_OBJECT_0 == dwRes) {
    return PortableEventOk;
  } else {
    if (WAIT_TIMEOUT == dwRes) {
      return PortableEventTimeout;
    } else {
      return PortableEventFailed;
    }
  }
}

#endif
