#pragma once

#include <objmodel.h>

class CDeviceStatusWnd : public Gtk::Frame, public IDeviceStatusWnd
{
public:
  CDeviceStatusWnd(ISysMonWnd* pParent, bool_t bVisible);
  virtual ~CDeviceStatusWnd();
  // IDeviceStatusWnd interface
  void deviceChanged();
  bool_t doClearDeviceErrors();
  control_handle_t getNativeControl() { return *this; }
  ISysMonWnd* getParent() const { return m_pParent; }
  void numDeviceChanged();
  void update();

protected:
  void onButtonClear();

protected:
  ISysMonWnd* m_pParent;
  Gtk::HBox m_hboxCtl;
  Gtk::VBox m_rawVboxCtl;
  Gtk::Label m_rawLabelCtl;
  Gtk::Frame m_rawFrameCtl;
  Gtk::ListViewText m_rawListCtl;
  Gtk::ScrolledWindow m_rawScrollCtl;
  Gtk::VBox m_decVboxCtl;
  Gtk::Label m_decLabelCtl;
  Gtk::Frame m_decFrameCtl;
  Gtk::ListViewText m_decListCtl;
  Gtk::ScrolledWindow m_decScrollCtl;
  Gtk::Button m_clearCtl;
  Gtk::HBox m_clearHboxCtl;
  Gtk::Label m_clearLabelCtl;
  Gtk::VBox m_vboxCtl;
  unsigned int m_numDevice;
  /* Following members enable this application to work even if version of admxrc3[d].dll used doesn't have certain entry points */
  bool_t m_bFunctionalityAvailable;
  Gtk::Label m_notAvailableCtl;
  void* m_pAdmxrc3So;
  typedef ADMXRC3_STATUS ADMXRC3_GETDEVICESTATUS(ADMXRC3_HANDLE hDevice, uint32_t flags, ADMXRC3_DEVICE_STATUS* pDeviceStatus, bool_t* pbAnyError);
  typedef ADMXRC3_STATUS ADMXRC3_CLEARDEVICEERRORS(ADMXRC3_HANDLE hDevice);
  ADMXRC3_GETDEVICESTATUS* m_pAdmxrc3GetDeviceStatus;
  ADMXRC3_CLEARDEVICEERRORS* m_pAdmxrc3ClearDeviceErrors;
};
