#pragma once

#include <objmodel.h>

class CGraphWnd : public Gtk::Frame, public IGraphWnd
{
public:
	CGraphWnd(ISysMonWnd* pParent, unsigned int index, bool_t bVisible);
	virtual ~CGraphWnd();
  // IDeviceInfoWnd interface
  void deviceChanged();
  void update(timestamp_t timestamp);
  void started();
  void viewChanged(timestamp_t interval, timestamp_t minShow, timestamp_t maxShow);
  control_handle_t getNativeControl() { return *this; }
  ISysMonWnd* getParent() const { return m_pParent; }
  IGraphWndToolbar* getToolbar(void) const { return m_pToolbar; }
  IScopeWnd* getScope() const { return m_pScope; }
  timestamp_t getCurrentTimestamp() const { return m_currentTimestamp; }
  timestamp_t getStartTimestamp() const { return m_startTimestamp; }
  void setIndex(unsigned int index);

protected:
  ISysMonWnd* m_pParent;
  IGraphWndToolbar* m_pToolbar;
  IScopeWnd* m_pScope;
  unsigned int m_index;
  Gtk::VBox m_vBoxCtl;
  timestamp_t m_currentTimestamp;
  timestamp_t m_startTimestamp;
};
