#pragma once

#include <objmodel.h>

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

class CDeviceStatusWnd : public CWnd, public IDeviceStatusWnd
{
	DECLARE_DYNAMIC(CDeviceStatusWnd)

public:
	CDeviceStatusWnd(ISysMonWnd* pParent, bool_t bVisible);
	virtual ~CDeviceStatusWnd();
  // IDeviceStatusWnd interface
  void deviceChanged();
  bool_t doClearDeviceErrors();
  control_handle_t getNativeControl() { return *this; }
  ISysMonWnd* getParent() const { return m_pParent; }
  void numDeviceChanged();
  void update();

protected:
  ISysMonWnd* m_pParent;
  unsigned int m_numDevice;
  CFont m_font;
  CBrush m_bgBrush;
  CStatic m_decLabelCtl;
  CListCtrl m_decListCtl;
  CStatic m_rawLabelCtl;
  CListCtrl m_rawListCtl;
  CButton m_clearCtl;
  CStatic m_clearLabelCtl;
  BOOL m_bInAdminGroup;
  /* Following members enable this application to work even if version of admxrc3[d].dll used doesn't have certain entry points */
  BOOL m_bFunctionalityAvailable;
  CStatic m_notAvailableCtl;
  HMODULE m_hAdmxrc3Dll;
  typedef ADMXRC3_STATUS ADMXRC3_GETDEVICESTATUS(ADMXRC3_HANDLE hDevice, UINT32 flags, ADMXRC3_DEVICE_STATUS* pDeviceStatus, BOOL* pbAnyError);
  typedef ADMXRC3_STATUS ADMXRC3_CLEARDEVICEERRORS(ADMXRC3_HANDLE hDevice);
  ADMXRC3_GETDEVICESTATUS* m_pAdmxrc3GetDeviceStatus;
  ADMXRC3_CLEARDEVICEERRORS* m_pAdmxrc3ClearDeviceErrors;

protected:
  DECLARE_MESSAGE_MAP()

protected:
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
  afx_msg void OnButtonClearErrors();
};
