#pragma once

#include <objmodel.h>
#include "sysmonwnd.h"

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

class CGraphWnd : public CWnd, public IGraphWnd
{
	DECLARE_DYNAMIC(CGraphWnd)

public:
	CGraphWnd(ISysMonWnd* pParent, unsigned int index, bool_t bVisible);
	virtual ~CGraphWnd();
  // IDeviceInfoWnd interface
  void deviceChanged();
  void update(timestamp_t timestamp);
  void started();
  void viewChanged(timestamp_t interval, timestamp_t minShow, timestamp_t maxShow);
  timestamp_t getCurrentTimestamp() const { return m_currentTimestamp; }
  control_handle_t getNativeControl() { return *this; }
  ISysMonWnd* getParent() const { return m_pParent; }
  IScopeWnd* getScope() const { return m_pScope; }
  IGraphWndToolbar* getToolbar(void) const { return m_pToolbar; }
  timestamp_t getStartTimestamp() const { return m_startTimestamp; }
  void setIndex(unsigned int index);

protected:
  ISysMonWnd* m_pParent;
  IGraphWndToolbar* m_pToolbar;
  IScopeWnd* m_pScope;
  unsigned int m_index;
  timestamp_t m_currentTimestamp;
  timestamp_t m_startTimestamp;
  CScrollBar* m_pScrollbar;

  DECLARE_MESSAGE_MAP()

protected:
  afx_msg void OnDestroy();
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
};
