#pragma once

#include <objmodel.h>
#include "iconbutton.h"
#include "stripedline.h"

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

class CGraphWndToolbar : public CWnd, public IGraphWndToolbar
{
	DECLARE_DYNAMIC(CGraphWndToolbar)

public:
	CGraphWndToolbar(IGraphWnd* pParent, unsigned int index);
	virtual ~CGraphWndToolbar();
  // IGraphWndToolbar interface
  void deviceChanged();
  control_handle_t getNativeControl() { return *this; }
  IGraphWnd* getParent() const { return m_pParent; }
  bool_t getPaused() const { return m_bPaused; }
  void keyClosed();
  void numGraphWndChanged();
  void numTraceChanged();
  void setIndex(unsigned int index);
  void tracesChanged();

protected:
  IGraphWnd* m_pParent;
  CFont m_font;
  CBrush m_bgBrush;
  CIconButton m_tempCtl;
  CIconButton m_voltCtl;
  CIconButton m_ampCtl;
  CIconButton m_boolCtl;
  CIconButton m_pauseCtl;
  CIconButton m_goCtl;
  CIconButton m_closeCtl;
  CIconButton m_plusCtl;
  CToolTipCtrl m_toolTipCtl;
  bool_t m_bPaused;
  unsigned int m_index;
  CButton m_keyCtl;
  IScopeKey* m_pKey;
  bool_t m_bFirstShowKey;

protected:
  void addSensors(ADMXRC3_DATA_TYPE datatype);
  void addSensors(ADMXRC3_UNIT_TYPE unit);
  void adjustScale(float value);
  void drawKey(BOOL bPaintNotErase, HDC hDC);
  virtual bool_t PreTranslateMessage(MSG* pMsg);

  DECLARE_MESSAGE_MAP()

protected:
  afx_msg void OnButtonAmp();
  afx_msg void OnButtonBool();
  afx_msg void OnButtonClose();
  afx_msg void OnButtonGo();
  afx_msg void OnButtonPause();
  afx_msg void OnButtonPlus();
  afx_msg void OnButtonVolt();
  afx_msg void OnButtonTemp();
  afx_msg void OnButtonKey();
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
};
